
% Run this script from Matlab under Unix to build the mex_* files.
%
% Unix
%	-I/usr/include/boost/tr1 -lboost_serialization ...
%
% If your system comes with boost 1.45 or higher installed, you should not
% need to adjust any pathnames.  Run "mex -setup" from within Matlab to
% configure the compiler.  You need GCC 4.5 or higher.

if 1
mex -g -O -output mex_grante_sample -I../ mex_grante_sample.cpp matlab_helpers.cpp ...
	-largeArrayDims ...
	-I/usr/include/boost/tr1 -lboost_serialization ...
	../Factor.cpp ../FactorGraph.cpp ../FactorGraphModel.cpp ../FactorType.cpp ...
	../FactorGraphStructurizer.cpp ../DisjointSet.cpp ../LogSumExp.cpp ../TreeInference.cpp ...
	../GibbsSampler.cpp ../FunctionMinimization.cpp ../FunctionMinimizationProblem.cpp ...
	../Likelihood.cpp ../InferenceMethod.cpp ../ParameterEstimationMethod.cpp ...
	../MaximumLikelihood.cpp ../FactorGraphObservation.cpp ../Prior.cpp ../NormalPrior.cpp ...
	../LaplacePrior.cpp ../MaximumPseudolikelihood.cpp ../FactorGraphUtility.cpp ...
	../Pseudolikelihood.cpp ../StudentTPrior.cpp ...
	../StructuredLossFunction.cpp ../StructuredHammingLoss.cpp ../StructuredSVM.cpp ...
	../StochasticFunctionMinimizationProblem.cpp ../StochasticFunctionMinimization.cpp ...
	../StructuredPerceptron.cpp ../RandomFactorGraphGenerator.cpp ...
	../VAcyclicDecomposition.cpp ../SubFactorGraph.cpp ...
	../FactorConditioningTable.cpp ../ConditionedFactorType.cpp ...
	../Conditioning.cpp ../MaximumCompositeLikelihood.cpp ...
	../TreeCoverDecomposition.cpp ../LinearProgrammingMAPInference.cpp ...
	../FactorDataSource.cpp ../BeliefPropagation.cpp ...
	../FactorGraphPartialObservation.cpp ...
	../RBFNetworkRegression.cpp ../RBFNetwork.cpp ../NonlinearRBFFactorType.cpp ...
	../GibbsInference.cpp ../StructuredMeanFieldInference.cpp ...
	../ExpectationMaximization.cpp ../RandomSource.cpp ../AISInference.cpp ...
	../SimulatedAnnealingInference.cpp ../MaximumCrissCrossLikelihood.cpp ...
	../DiffusionInference.cpp ../BruteForceExactInference.cpp ...
	../LinearFactorType.cpp ../NaivePiecewiseTraining.cpp ...
	../ContrastiveDivergence.cpp ../ContrastiveDivergenceTraining.cpp ...
	../HyperbolicPrior.cpp ../CompositeMinimization.cpp ...
	../CompositeMinimizationProblem.cpp ...
	../SwendsenWangSampler.cpp ../SwendsenWangInference.cpp ...
	../ParallelTemperingInference.cpp ../SAMCInference.cpp ../TestModels.cpp
end

mex -g -O -output mex_grante_infer -I../ mex_grante_infer.cpp matlab_helpers.cpp ...
	-largeArrayDims ...
	-I/usr/include/boost/tr1 -lboost_serialization ...
	../Factor.cpp ../FactorGraph.cpp ../FactorGraphModel.cpp ../FactorType.cpp ...
	../FactorGraphStructurizer.cpp ../DisjointSet.cpp ../LogSumExp.cpp ../TreeInference.cpp ...
	../GibbsSampler.cpp ../FunctionMinimization.cpp ../FunctionMinimizationProblem.cpp ...
	../Likelihood.cpp ../InferenceMethod.cpp ../ParameterEstimationMethod.cpp ...
	../MaximumLikelihood.cpp ../FactorGraphObservation.cpp ../Prior.cpp ../NormalPrior.cpp ...
	../LaplacePrior.cpp ../MaximumPseudolikelihood.cpp ../FactorGraphUtility.cpp ...
	../Pseudolikelihood.cpp ../StudentTPrior.cpp ...
	../StructuredLossFunction.cpp ../StructuredHammingLoss.cpp ../StructuredSVM.cpp ...
	../StochasticFunctionMinimizationProblem.cpp ../StochasticFunctionMinimization.cpp ...
	../StructuredPerceptron.cpp ../RandomFactorGraphGenerator.cpp ...
	../VAcyclicDecomposition.cpp ../SubFactorGraph.cpp ...
	../FactorConditioningTable.cpp ../ConditionedFactorType.cpp ...
	../Conditioning.cpp ../MaximumCompositeLikelihood.cpp ...
	../TreeCoverDecomposition.cpp ../LinearProgrammingMAPInference.cpp ...
	../FactorDataSource.cpp ../BeliefPropagation.cpp ...
	../FactorGraphPartialObservation.cpp ...
	../RBFNetworkRegression.cpp ../RBFNetwork.cpp ../NonlinearRBFFactorType.cpp ...
	../GibbsInference.cpp ../StructuredMeanFieldInference.cpp ...
	../ExpectationMaximization.cpp ../RandomSource.cpp ../AISInference.cpp ...
	../SimulatedAnnealingInference.cpp ../MaximumCrissCrossLikelihood.cpp ...
	../DiffusionInference.cpp ../BruteForceExactInference.cpp ...
	../LinearFactorType.cpp ../NaivePiecewiseTraining.cpp ...
	../ContrastiveDivergence.cpp ../ContrastiveDivergenceTraining.cpp ...
	../HyperbolicPrior.cpp ../CompositeMinimization.cpp ...
	../CompositeMinimizationProblem.cpp ...
	../SwendsenWangSampler.cpp ../SwendsenWangInference.cpp ...
	../ParallelTemperingInference.cpp ../SAMCInference.cpp ../TestModels.cpp

if 1
mex -g -O -output mex_grante_learn -I../ mex_grante_learn.cpp matlab_helpers.cpp ...
	-largeArrayDims ...
	-I/usr/include/boost/tr1 -lboost_serialization ...
	../Factor.cpp ../FactorGraph.cpp ../FactorGraphModel.cpp ../FactorType.cpp ...
	../FactorGraphStructurizer.cpp ../DisjointSet.cpp ../LogSumExp.cpp ../TreeInference.cpp ...
	../GibbsSampler.cpp ../FunctionMinimization.cpp ../FunctionMinimizationProblem.cpp ...
	../Likelihood.cpp ../InferenceMethod.cpp ../ParameterEstimationMethod.cpp ...
	../MaximumLikelihood.cpp ../FactorGraphObservation.cpp ../Prior.cpp ../NormalPrior.cpp ...
	../LaplacePrior.cpp ../MaximumPseudolikelihood.cpp ../FactorGraphUtility.cpp ...
	../Pseudolikelihood.cpp ../StudentTPrior.cpp ...
	../StructuredLossFunction.cpp ../StructuredHammingLoss.cpp ../StructuredSVM.cpp ...
	../StochasticFunctionMinimizationProblem.cpp ../StochasticFunctionMinimization.cpp ...
	../StructuredPerceptron.cpp ../RandomFactorGraphGenerator.cpp ...
	../VAcyclicDecomposition.cpp ../SubFactorGraph.cpp ...
	../FactorConditioningTable.cpp ../ConditionedFactorType.cpp ...
	../Conditioning.cpp ../MaximumCompositeLikelihood.cpp ...
	../TreeCoverDecomposition.cpp ../LinearProgrammingMAPInference.cpp ...
	../FactorDataSource.cpp ../BeliefPropagation.cpp ...
	../FactorGraphPartialObservation.cpp ...
	../RBFNetworkRegression.cpp ../RBFNetwork.cpp ../NonlinearRBFFactorType.cpp ...
	../GibbsInference.cpp ../StructuredMeanFieldInference.cpp ...
	../ExpectationMaximization.cpp ../RandomSource.cpp ../AISInference.cpp ...
	../SimulatedAnnealingInference.cpp ../MaximumCrissCrossLikelihood.cpp ...
	../DiffusionInference.cpp ../BruteForceExactInference.cpp ...
	../LinearFactorType.cpp ../NaivePiecewiseTraining.cpp ...
	../ContrastiveDivergence.cpp ../ContrastiveDivergenceTraining.cpp ...
	../HyperbolicPrior.cpp ../CompositeMinimization.cpp ...
	../CompositeMinimizationProblem.cpp ...
	../SwendsenWangSampler.cpp ../SwendsenWangInference.cpp ...
	../ParallelTemperingInference.cpp ../SAMCInference.cpp ../TestModels.cpp
end

mex -g -O -output mex_grante_evaluate -I../ mex_grante_evaluate.cpp matlab_helpers.cpp ...
	-largeArrayDims ...
	-I/usr/include/boost/tr1 -lboost_serialization ...
	../Factor.cpp ../FactorGraph.cpp ../FactorGraphModel.cpp ../FactorType.cpp ...
	../FactorGraphStructurizer.cpp ../DisjointSet.cpp ../LogSumExp.cpp ../TreeInference.cpp ...
	../GibbsSampler.cpp ../FunctionMinimization.cpp ../FunctionMinimizationProblem.cpp ...
	../Likelihood.cpp ../InferenceMethod.cpp ../ParameterEstimationMethod.cpp ...
	../MaximumLikelihood.cpp ../FactorGraphObservation.cpp ../Prior.cpp ../NormalPrior.cpp ...
	../LaplacePrior.cpp ../MaximumPseudolikelihood.cpp ../FactorGraphUtility.cpp ...
	../Pseudolikelihood.cpp ../StudentTPrior.cpp ...
	../StructuredLossFunction.cpp ../StructuredHammingLoss.cpp ../StructuredSVM.cpp ...
	../StochasticFunctionMinimizationProblem.cpp ../StochasticFunctionMinimization.cpp ...
	../StructuredPerceptron.cpp ../RandomFactorGraphGenerator.cpp ...
	../VAcyclicDecomposition.cpp ../SubFactorGraph.cpp ...
	../FactorConditioningTable.cpp ../ConditionedFactorType.cpp ...
	../Conditioning.cpp ../MaximumCompositeLikelihood.cpp ...
	../TreeCoverDecomposition.cpp ../LinearProgrammingMAPInference.cpp ...
	../FactorDataSource.cpp ../BeliefPropagation.cpp ...
	../FactorGraphPartialObservation.cpp ...
	../RBFNetworkRegression.cpp ../RBFNetwork.cpp ../NonlinearRBFFactorType.cpp ...
	../GibbsInference.cpp ../StructuredMeanFieldInference.cpp ...
	../ExpectationMaximization.cpp ../RandomSource.cpp ../AISInference.cpp ...
	../SimulatedAnnealingInference.cpp ../MaximumCrissCrossLikelihood.cpp ...
	../DiffusionInference.cpp ../BruteForceExactInference.cpp ...
	../LinearFactorType.cpp ../NaivePiecewiseTraining.cpp ...
	../ContrastiveDivergence.cpp ../ContrastiveDivergenceTraining.cpp ...
	../HyperbolicPrior.cpp ../CompositeMinimization.cpp ...
	../CompositeMinimizationProblem.cpp ...
	../SwendsenWangSampler.cpp ../SwendsenWangInference.cpp ...
	../ParallelTemperingInference.cpp ../SAMCInference.cpp ../TestModels.cpp
