
% How to compile mex files for your Windows system:
%
%   1. Adjust all boost pathes to the directory you installed boost into.
%   2. From within Matlab run "mex -setup" to configure your compiler.
%   3. Go into the grante\src\matlab folder and run "make_win".

disp('Building mex files, this can take a while (15 minutes)');

if 1
disp('Building mex_grante_sample...');
mex -g -O -output mex_grante_sample -I../ mex_grante_sample.cpp matlab_helpers.cpp ...
	COMPFLAGS="/openmp $COMPFLAGS" ...
	-largeArrayDims ...
	-IC:\boost64\include\boost-1_45 ...
	-IC:\boost64\include\boost-1_45\boost\tr1 ...
	-LC:\boost64\lib ...
	C:\boost64\lib\libboost_serialization-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99f-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99l-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1f-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1l-vc100-mt-1_45.lib ...
	../Factor.cpp ../FactorGraph.cpp ../FactorGraphModel.cpp ../FactorType.cpp ...
	../FactorGraphStructurizer.cpp ../DisjointSet.cpp ../LogSumExp.cpp ../TreeInference.cpp ...
	../GibbsSampler.cpp ../FunctionMinimization.cpp ../FunctionMinimizationProblem.cpp ...
	../Likelihood.cpp ../InferenceMethod.cpp ../ParameterEstimationMethod.cpp ...
	../MaximumLikelihood.cpp ../FactorGraphObservation.cpp ../Prior.cpp ../NormalPrior.cpp ...
	../LaplacePrior.cpp ../MaximumPseudolikelihood.cpp ../FactorGraphUtility.cpp ...
	../Pseudolikelihood.cpp ../StudentTPrior.cpp ...
	../StructuredLossFunction.cpp ../StructuredHammingLoss.cpp ../StructuredSVM.cpp ...
	../StochasticFunctionMinimizationProblem.cpp ../StochasticFunctionMinimization.cpp ...
	../StructuredPerceptron.cpp ../RandomFactorGraphGenerator.cpp ...
	../VAcyclicDecomposition.cpp ../SubFactorGraph.cpp ...
	../FactorConditioningTable.cpp ../ConditionedFactorType.cpp ...
	../Conditioning.cpp ../MaximumCompositeLikelihood.cpp ...
	../TreeCoverDecomposition.cpp ../LinearProgrammingMAPInference.cpp ...
	../FactorDataSource.cpp ../BeliefPropagation.cpp ...
	../FactorGraphPartialObservation.cpp ...
	../RBFNetworkRegression.cpp ../RBFNetwork.cpp ../NonlinearRBFFactorType.cpp ...
	../GibbsInference.cpp ../StructuredMeanFieldInference.cpp ...
	../ExpectationMaximization.cpp ../RandomSource.cpp ../AISInference.cpp ...
	../SimulatedAnnealingInference.cpp ../MaximumCrissCrossLikelihood.cpp ...
	../DiffusionInference.cpp ../BruteForceExactInference.cpp ...
	../LinearFactorType.cpp ../NaivePiecewiseTraining.cpp ...
	../ContrastiveDivergence.cpp ../ContrastiveDivergenceTraining.cpp ...
	../HyperbolicPrior.cpp ../CompositeMinimization.cpp ...
	../CompositeMinimizationProblem.cpp ...
	../SwendsenWangSampler.cpp ../SwendsenWangInference.cpp ...
	../ParallelTemperingInference.cpp ../SAMCInference.cpp ../TestModels.cpp ...
	../NaiveMeanFieldInference.cpp ../DisjointSetBT.cpp ...
	../MultichainGibbsInference.cpp
end

if 1
disp('Building mex_grante_infer...');
mex -g -O -output mex_grante_infer -I../ mex_grante_infer.cpp matlab_helpers.cpp ...
	COMPFLAGS="/openmp $COMPFLAGS" ...
	-largeArrayDims ...
	-IC:\boost64\include\boost-1_45 ...
	-IC:\boost64\include\boost-1_45\boost\tr1 ...
	-LC:\boost64\lib ...
	C:\boost64\lib\libboost_serialization-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99f-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99l-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1f-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1l-vc100-mt-1_45.lib ...
	../Factor.cpp ../FactorGraph.cpp ../FactorGraphModel.cpp ../FactorType.cpp ...
	../FactorGraphStructurizer.cpp ../DisjointSet.cpp ../LogSumExp.cpp ../TreeInference.cpp ...
	../GibbsSampler.cpp ../FunctionMinimization.cpp ../FunctionMinimizationProblem.cpp ...
	../Likelihood.cpp ../InferenceMethod.cpp ../ParameterEstimationMethod.cpp ...
	../MaximumLikelihood.cpp ../FactorGraphObservation.cpp ../Prior.cpp ../NormalPrior.cpp ...
	../LaplacePrior.cpp ../MaximumPseudolikelihood.cpp ../FactorGraphUtility.cpp ...
	../Pseudolikelihood.cpp ../StudentTPrior.cpp ...
	../StructuredLossFunction.cpp ../StructuredHammingLoss.cpp ../StructuredSVM.cpp ...
	../StochasticFunctionMinimizationProblem.cpp ../StochasticFunctionMinimization.cpp ...
	../StructuredPerceptron.cpp ../RandomFactorGraphGenerator.cpp ...
	../VAcyclicDecomposition.cpp ../SubFactorGraph.cpp ...
	../FactorConditioningTable.cpp ../ConditionedFactorType.cpp ...
	../Conditioning.cpp ../MaximumCompositeLikelihood.cpp ...
	../TreeCoverDecomposition.cpp ../LinearProgrammingMAPInference.cpp ...
	../FactorDataSource.cpp ../BeliefPropagation.cpp ...
	../FactorGraphPartialObservation.cpp ...
	../RBFNetworkRegression.cpp ../RBFNetwork.cpp ../NonlinearRBFFactorType.cpp ...
	../GibbsInference.cpp ../StructuredMeanFieldInference.cpp ...
	../ExpectationMaximization.cpp ../RandomSource.cpp ../AISInference.cpp ...
	../SimulatedAnnealingInference.cpp ../MaximumCrissCrossLikelihood.cpp ...
	../DiffusionInference.cpp ../BruteForceExactInference.cpp ...
	../LinearFactorType.cpp ../NaivePiecewiseTraining.cpp ...
	../ContrastiveDivergence.cpp ../ContrastiveDivergenceTraining.cpp ...
	../HyperbolicPrior.cpp ../CompositeMinimization.cpp ...
	../CompositeMinimizationProblem.cpp ...
	../SwendsenWangSampler.cpp ../SwendsenWangInference.cpp ...
	../ParallelTemperingInference.cpp ../SAMCInference.cpp ../TestModels.cpp ...
	../NaiveMeanFieldInference.cpp ../DisjointSetBT.cpp ...
	../MultichainGibbsInference.cpp
end

if 1
disp('Building mex_grante_learn...');
mex -O -g -output mex_grante_learn -I../ mex_grante_learn.cpp matlab_helpers.cpp ...
	COMPFLAGS="/openmp $COMPFLAGS" ...
	-largeArrayDims ...
	-IC:\boost64\include\boost-1_45 ...
	-IC:\boost64\include\boost-1_45\boost\tr1 ...
	-LC:\boost64\lib ...
	C:\boost64\lib\libboost_serialization-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99f-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99l-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1f-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1l-vc100-mt-1_45.lib ...
	../Factor.cpp ../FactorGraph.cpp ../FactorGraphModel.cpp ../FactorType.cpp ...
	../FactorGraphStructurizer.cpp ../DisjointSet.cpp ../LogSumExp.cpp ../TreeInference.cpp ...
	../GibbsSampler.cpp ../FunctionMinimization.cpp ../FunctionMinimizationProblem.cpp ...
	../Likelihood.cpp ../InferenceMethod.cpp ../ParameterEstimationMethod.cpp ...
	../MaximumLikelihood.cpp ../FactorGraphObservation.cpp ../Prior.cpp ../NormalPrior.cpp ...
	../LaplacePrior.cpp ../MaximumPseudolikelihood.cpp ../FactorGraphUtility.cpp ...
	../Pseudolikelihood.cpp ../StudentTPrior.cpp ...
	../StructuredLossFunction.cpp ../StructuredHammingLoss.cpp ../StructuredSVM.cpp ...
	../StochasticFunctionMinimizationProblem.cpp ../StochasticFunctionMinimization.cpp ...
	../StructuredPerceptron.cpp ../RandomFactorGraphGenerator.cpp ...
	../VAcyclicDecomposition.cpp ../SubFactorGraph.cpp ...
	../FactorConditioningTable.cpp ../ConditionedFactorType.cpp ...
	../Conditioning.cpp ../MaximumCompositeLikelihood.cpp ...
	../TreeCoverDecomposition.cpp ../LinearProgrammingMAPInference.cpp ...
	../FactorDataSource.cpp ../BeliefPropagation.cpp ...
	../FactorGraphPartialObservation.cpp ...
	../RBFNetworkRegression.cpp ../RBFNetwork.cpp ../NonlinearRBFFactorType.cpp ...
	../GibbsInference.cpp ../StructuredMeanFieldInference.cpp ...
	../ExpectationMaximization.cpp ../RandomSource.cpp ../AISInference.cpp ...
	../SimulatedAnnealingInference.cpp ../MaximumCrissCrossLikelihood.cpp ...
	../DiffusionInference.cpp ../BruteForceExactInference.cpp ...
	../LinearFactorType.cpp ../NaivePiecewiseTraining.cpp ...
	../ContrastiveDivergence.cpp ../ContrastiveDivergenceTraining.cpp ...
	../HyperbolicPrior.cpp ../CompositeMinimization.cpp ...
	../CompositeMinimizationProblem.cpp ...
	../SwendsenWangSampler.cpp ../SwendsenWangInference.cpp ...
	../ParallelTemperingInference.cpp ../SAMCInference.cpp ../TestModels.cpp ...
	../NaiveMeanFieldInference.cpp ../DisjointSetBT.cpp ...
	../MultichainGibbsInference.cpp
end

if 1
disp('Building mex_grante_evaluate...');
mex -g -O -output mex_grante_evaluate -I../ mex_grante_evaluate.cpp matlab_helpers.cpp ...
	COMPFLAGS="/openmp $COMPFLAGS" ...
	-largeArrayDims ...
	-IC:\boost64\include\boost-1_45 ...
	-IC:\boost64\include\boost-1_45\boost\tr1 ...
	-LC:\boost64\lib ...
	C:\boost64\lib\libboost_serialization-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99f-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_c99l-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1f-vc100-mt-1_45.lib ...
	C:\boost64\lib\libboost_math_tr1l-vc100-mt-1_45.lib ...
	../Factor.cpp ../FactorGraph.cpp ../FactorGraphModel.cpp ../FactorType.cpp ...
	../FactorGraphStructurizer.cpp ../DisjointSet.cpp ../LogSumExp.cpp ../TreeInference.cpp ...
	../GibbsSampler.cpp ../FunctionMinimization.cpp ../FunctionMinimizationProblem.cpp ...
	../Likelihood.cpp ../InferenceMethod.cpp ../ParameterEstimationMethod.cpp ...
	../MaximumLikelihood.cpp ../FactorGraphObservation.cpp ../Prior.cpp ../NormalPrior.cpp ...
	../LaplacePrior.cpp ../MaximumPseudolikelihood.cpp ../FactorGraphUtility.cpp ...
	../Pseudolikelihood.cpp ../StudentTPrior.cpp ...
	../StructuredLossFunction.cpp ../StructuredHammingLoss.cpp ../StructuredSVM.cpp ...
	../StochasticFunctionMinimizationProblem.cpp ../StochasticFunctionMinimization.cpp ...
	../StructuredPerceptron.cpp ../RandomFactorGraphGenerator.cpp ...
	../VAcyclicDecomposition.cpp ../SubFactorGraph.cpp ...
	../FactorConditioningTable.cpp ../ConditionedFactorType.cpp ...
	../Conditioning.cpp ../MaximumCompositeLikelihood.cpp ...
	../TreeCoverDecomposition.cpp ../LinearProgrammingMAPInference.cpp ...
	../FactorDataSource.cpp ../BeliefPropagation.cpp ...
	../FactorGraphPartialObservation.cpp ...
	../RBFNetworkRegression.cpp ../RBFNetwork.cpp ../NonlinearRBFFactorType.cpp ...
	../GibbsInference.cpp ../StructuredMeanFieldInference.cpp ...
	../ExpectationMaximization.cpp ../RandomSource.cpp ../AISInference.cpp ...
	../SimulatedAnnealingInference.cpp ../MaximumCrissCrossLikelihood.cpp ...
	../DiffusionInference.cpp ../BruteForceExactInference.cpp ...
	../LinearFactorType.cpp ../NaivePiecewiseTraining.cpp ...
	../ContrastiveDivergence.cpp ../ContrastiveDivergenceTraining.cpp ...
	../HyperbolicPrior.cpp ../CompositeMinimization.cpp ...
	../CompositeMinimizationProblem.cpp ...
	../SwendsenWangSampler.cpp ../SwendsenWangInference.cpp ...
	../ParallelTemperingInference.cpp ../SAMCInference.cpp ../TestModels.cpp ...
	../NaiveMeanFieldInference.cpp ../DisjointSetBT.cpp ...
	../MultichainGibbsInference.cpp
end

